<?xml version="1.0" encoding="UTF-8"?>
<!DOCTYPE composition PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN"
    "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">

<!--
IGAC proyecto SNC

@autor			pedro.garcia
@description 	página principal del CU
@cu             cu-sa-ac-009
@mb             GeneracionOrdenPracticaMB
@version 		2.0


-->

<ui:composition xmlns="http://www.w3.org/1999/xhtml"
                xmlns:p="http://primefaces.org/ui"
                xmlns:h="http://java.sun.com/jsf/html"
                xmlns:f="http://java.sun.com/jsf/core"
                xmlns:ui="http://java.sun.com/jsf/facelets"
                xmlns:predio="http://java.sun.com/jsf/composite/predio"
                xmlns:misc="http://java.sun.com/jsf/composite/misc"
                template="/templates/generalCU.xhtml">

    <ui:define name="title">
        .::Sistema Nacional Catastral::. .::Generar orden de práctica de avalúos::.
    </ui:define>

    <ui:define name="content">

        <p:tabView id="amindOrdenPracticaTV" dynamic="true">

            <p:ajax event="tabChange"
                    listener="#{generacionOrdenPractica.onTabChange}"
                    update=":amindOrdenPracticaTV" onstart="statusDialog2.show();"
                    oncomplete="statusDialog2.hide();" />

            <p:tab title="Trámites para asignar ordenes de práctica"
                   id="generarOrdenPracticaTAB">

                <p:messages id="generarOPMsgs" showDetail="false" />

                <h:form id="generacionOrdenPracticaForm">

                    <legend>
                        <h:outputText value="Generar orden de práctica"
                                      styleClass="legendTitle" />
                    </legend>

                    <h:panelGrid columns="1" width="100%" cellspacing="7">

                        <p:dataTable value="#{generacionOrdenPractica.lazyWorkingAvaluos}"
                                     var="avaluo" widgetVar="avaluosParaOPDTWV" rowKey="#{avaluo.id}"
                                     paginator="true" rows="10"
                                     selection="#{generacionOrdenPractica.selectedAvaluosForOP}"
                                     paginatorTemplate="{RowsPerPageDropdown} {FirstPageLink} {PreviousPageLink} {CurrentPageReport}
                                     {NextPageLink} {LastPageLink}"
                                     rowsPerPageTemplate="10,20,30" paginatorPosition="bottom"
                                     emptyMessage="No se encontraron trámites de avalúos">

                            <f:facet name="header">
                                Trámites asignados y disponibles para incluir en la orden de práctica
                            </f:facet>

                            <p:column selectionMode="multiple" style="width:18px" />

                            <p:column headerText="Opciones" style="left: 0;width: 250px;">
                                <p:commandButton title="Consultar ordenes por avaluador"
                                                 icon="ui-icon-search" value="Por avaluador"
                                                 onclick="alert('falta integrar con CU 111 (no hecho)');" />
                                <p:spacer width="5" height="0" />
                                <p:commandButton title="Consultar ordenes por radicación"
                                                 icon="ui-icon-search" value="Por radicación"
                                                 onclick="alert('falta integrar con CU 112');" />
                                <p:spacer width="5" height="0" />
                                <p:commandButton title="Consultar información predial"
                                                 icon="ui-icon-home"
                                                 action="#{consultaInformacionPredial.cargarInformacionPredial}"
                                                 update=":prediosAvaluoForm" onstart="statusDialog2.show();"
                                                 oncomplete="statusDialog2.hide();
                                                 handleCompleteSIC(xhr, status, args, infoPredialWV, true);">
                                    <f:setPropertyActionListener value="#{avaluo}"
                                                                 target="#{consultaInformacionPredial.avaluoSeleccionado}" />

                                </p:commandButton>
                            </p:column>

                            <p:column headerText="Número radicado">
                                <h:outputText
                                    value="#{avaluo.tramite.solicitud.numeroRadicacionDefinitiva}" />
                            </p:column>

                            <p:column headerText="Sec. radicado">
                                <h:outputText value="#{avaluo.secRadicado}" />
                            </p:column>

                            <p:column headerText="Solicitante">
                                <h:outputText
                                    value="#{avaluo.solicitanteTramite.nombreCompleto}" />
                            </p:column>

                            <p:column headerText="Departamento">
                                <p:commandLink
                                    value="#{avaluo.avaluoPredios[0].departamento.nombre}"
                                    rendered="#{avaluo.tienePrediosEnDiferentesDeptos}"
                                    styleClass="commandLinkStyle"
                                    action="#{consultarDptoMunpioAvaluo.cargarDeptosMunisAvaluo}"
                                    update=":consultarDepartamentosMunicipioForm"
                                    onstart="statusDialog2.show();"
                                    oncomplete="statusDialog2.hide();
                                    handleCompleteSIC(xhr, status, args, infoDeptosMunisWV, true);">
                                    <f:setPropertyActionListener value="#{avaluo}"
                                                                 target="#{consultarDptoMunpioAvaluo.avaluoSeleccionado}" />
                                </p:commandLink>

                                <h:outputText
                                    rendered="#{!avaluo.tienePrediosEnDiferentesDeptos}"
                                    value="#{avaluo.avaluoPredios[0].departamento.codigo} - #{avaluo.avaluoPredios[0].departamento.nombre}" />

                            </p:column>

                            <p:column headerText="Municipio">
                                <p:commandLink
                                    value="#{avaluo.avaluoPredios[0].municipio.nombre}"
                                    rendered="#{avaluo.tienePrediosEnDiferentesMunicipios}"
                                    styleClass="commandLinkStyle"
                                    action="#{consultarDptoMunpioAvaluo.cargarDeptosMunisAvaluo}"
                                    update=":consultarDepartamentosMunicipioForm"
                                    onstart="statusDialog2.show();"
                                    oncomplete="statusDialog2.hide();
                                    handleCompleteSIC(xhr, status, args, infoDeptosMunisWV, true);">
                                    <f:setPropertyActionListener value="#{avaluo}"
                                                                 target="#{consultarDptoMunpioAvaluo.avaluoSeleccionado}" />
                                </p:commandLink>

                                <h:outputText
                                    rendered="#{!avaluo.tienePrediosEnDiferentesMunicipios}"
                                    value="#{avaluo.avaluoPredios[0].municipio.codigo} - #{avaluo.avaluoPredios[0].municipio.nombre}" />

                            </p:column>

                            <p:column headerText="Avaluador">
                                <p:commandLink styleClass="commandLinkStyle"
                                               rendered="#{avaluo.tieneMultiplesAvaluadores}"
                                               value="#{avaluo.avaluoAsignacionProfesionals[0].profesionalAvaluo.nombreCompleto}"
                                               action="#{consultarAvaluadoresAsignados.cargarAvaluadoresAsignados}"
                                               update=":consultarAvaluadoresAsignadosPG"
                                               onstart="statusDialog2.show();"
                                               oncomplete="infoAvaluadoresAsignadosWV.show(); statusDialog2.hide();">
                                    <f:setPropertyActionListener value="#{avaluo.secRadicado}"
                                                                 target="#{consultarAvaluadoresAsignados.secRadicado}" />
                                </p:commandLink>
                                <h:outputText rendered="#{!avaluo.tieneMultiplesAvaluadores}"
                                              value="#{avaluo.avaluoAsignacionProfesionals[0].profesionalAvaluo.nombreCompleto}" />
                            </p:column>

                        </p:dataTable>

                        <p:commandButton id="generarOPBtn"
                                         value="Generar orden de práctica" icon="ui-icon-clipboard"
                                         onclick="if (avaluosParaOPDTWV.selection.length == 0) {
                                                     alert('Debe seleccionar al menos un trámite de avalúo');
                                                     return false;
                                                 }"
                                         action="#{generacionOrdenPractica.generarOrdenPracticaInit}"
                                         oncomplete="handleCompleteSIC(xhr, status, args, infoOrdenPracticaWV, true);"
                                         update=":amindOrdenPracticaTV:generarOPMsgs,
                                         :infoOrdenPracticaPG" />
                    </h:panelGrid>

                    <p:blockUI
                        block=":amindOrdenPracticaTV:generacionOrdenPracticaForm"
                        trigger="generarOPBtn">
                        Consultando información para la orden de práctica<br />
                        <p:graphicImage value="/images/loading.gif" />
                    </p:blockUI>


                </h:form>
            </p:tab>

            <p:tab title="Ordenes de práctica por enviar"
                   id="enviarOrdenesPracticaTAB">

                <p:messages id="enviarOPMsgs" showDetail="false" />

                <h:form id="envioOrdenPracticaForm">

                    <legend>
                        <h:outputText value="Enviar ordenes de práctica"
                                      styleClass="legendTitle" />
                    </legend>

                    <h:panelGrid columns="1" width="100%" cellspacing="7">

                        <p:dataTable
                            value="#{generacionOrdenPractica.ordenesPracticaPorEnviar}"
                            var="ordenPractica" rowKey="#{ordenPractica.id}"
                            selection="#{generacionOrdenPractica.ordenesPracticaSeleccionadas}"
                            paginatorTemplate="{RowsPerPageDropdown} {FirstPageLink} 
                            {PreviousPageLink} {CurrentPageReport} {NextPageLink} {LastPageLink}"
                            rowsPerPageTemplate="5,10,15"
                            emptyMessage="No existen ordenes de práctica pendientes por enviar"
                            paginator="true" rows="10" paginatorPosition="bottom">


                            <f:facet name="header">  
                                Ordenes de práctica por enviar
                            </f:facet>

                            <p:column selectionMode="multiple" style="width:18px" />

                            <p:column headerText="Número de orden">

                                <p:commandLink value="#{ordenPractica.numero}"
                                               styleClass="commandLinkStyle"
                                               action="#{generacionOrdenPractica.cargarOrdenParaEdicion}"
                                               update=":infoOrdenPracticaPG" onstart="statusDialog2.show();"
                                               oncomplete="statusDialog2.hide(); 
                                               handleCompleteSIC(xhr, status, args, infoOrdenPracticaWV, true);">
                                    <f:setPropertyActionListener value="#{ordenPractica}"
                                                                 target="#{generacionOrdenPractica.ordenPracticaSeleccionada}" />
                                </p:commandLink>
                            </p:column>

                            <p:column headerText="Fecha">
                                <h:outputText value="#{ordenPractica.fecha}"
                                              styleClass="outputTextStyle">
                                    <f:convertDateTime pattern="#{general.formatoFechaUsuario2}" />
                                </h:outputText>
                            </p:column>

                            <p:column headerText="Observaciones">
                                <h:outputText value="#{ordenPractica.observaciones}"
                                              styleClass="outputTextStyle" />
                            </p:column>

                            <p:column headerText="Ver documento">
                                <p:commandLink
                                    action="#{generacionOrdenPractica.cargarDocumentoOrdenPractica}"
                                    onstart="statusDialog2.show();"
                                    oncomplete="statusDialog2.hide(); 
                                    handleCompleteSIC(xhr, status, args, ordenPracticaWV, true);"
                                    update=":amindOrdenPracticaTV:enviarOrdenesPracticaTAB">
                                    <h:outputText value="Documento" styleClass="commandLinkStyle" />
                                    <f:setPropertyActionListener value="#{ordenPractica}"
                                                                 target="#{generacionOrdenPractica.ordenPracticaSeleccionada}" />
                                </p:commandLink>
                            </p:column>

                        </p:dataTable>

                        <p:commandButton value="Enviar ordenes seleccionadas"
                                         icon="ui-icon-mail-closed"
                                         action="#{generacionOrdenPractica.enviarOrdenesSeleccionadas}"
                                         update=":amindOrdenPracticaTV:enviarOrdenesPracticaTAB"
                                         onstart="statusDialog2.show();"
                                         oncomplete="statusDialog2.hide(); " />

                    </h:panelGrid>

                </h:form>

            </p:tab>

        </p:tabView>

        <h:form>
            <p:separator style="width:925px;height:3px" />
            <p:spacer height="7" width="0" />
            <p:outputPanel layout="block" style="text-align:right">
                <p:commandButton value="Cerrar"
                                 action="#{generacionOrdenPractica.cerrar}"
                                 icon="ui-icon-circle-close" immediate="true" ajax="false" />
                <p:spacer height="0" width="30" />
            </p:outputPanel>
            <p:spacer height="20" width="0" />
        </h:form>


        <!-- ............  dialogos de transversales .......  -->

        <!-- DIALOG PARA INFORMACION DE DEPARTAMENTOS Y MUNICIPIOS DE LOS PREDIOS DE UN AVALUO -->
        <p:dialog widgetVar="infoDeptosMunisWV"
                  header="Municipios y departamentos asociados al avalúo"
                  appendToBody="true" closable="true" minimizable="false"
                  resizable="false" dynamic="true" modal="true" width="600">
            <ui:include
                src="/avaluos/transversal/consultarDepartamentosMunicipiosAvaluo.xhtml" />
        </p:dialog>

        <!-- DIALOG PARA INFORMACION PREDIAL -->
        <p:dialog widgetVar="infoPredialWV"
                  header="Información de los predios asociados al avalúo"
                  appendToBody="true" closable="true" minimizable="false"
                  resizable="false" dynamic="true" modal="true" width="850">
            <ui:include
                src="/avaluos/transversal/consultarInformacionPredial.xhtml" />
        </p:dialog>

        <!-- DIALOG PARA INFORMACION DE AVALUADORES ASIGNADOS -->
        <p:dialog widgetVar="infoAvaluadoresAsignadosWV"
                  header="Profesionales de avalúos" appendToBody="true" closable="true"
                  minimizable="false" resizable="false" dynamic="true" modal="true"
                  width="750">
            <ui:include
                src="/avaluos/asignacion/consultarAvaluadoresAsignados.xhtml" />
        </p:dialog>

        <!-- ............  dialogos ............  -->

        <p:dialog header="Información orden de práctica a generar"
                  widgetVar="infoOrdenPracticaWV" appendToBody="true" closable="true"
                  minimizable="false" resizable="false" dynamic="true" modal="true"
                  height="500">
            <ui:include src="informacionGenerarOrdenPractica.xhtml" />
            <p:ajax event="close"
                    listener="#{generacionOrdenPractica.cancelarGeneracionOP}" />
        </p:dialog>

        <!-- ...................... composite components  ................................... -->

        <predio:detallesPredioCC id="dpCC" thisWVName="detallesPredioWV"
                                 mostrarDatosTramites="false" thisIdPlusColon=":dpCC"
                                 mostrarFichaPredial="false" />

        <misc:visualizadorMemorandosCC id="viewOrdenPractica"
                                       thisWVName="ordenPracticaWV"
                                       urlDocumento="#{generacionOrdenPractica.ordenPracticaReporteDTO.urlWebReporte}"
                                       fileContent="#{generacionOrdenPractica.ordenPracticaReporteDTO.streamedContentReporte}"
                                       documentoGenerado="#{generacionOrdenPractica.ordenPracticaReporteDTO ne null}"
                                       radicarButtonVisible="false" />

    </ui:define>

</ui:composition>
